#pragma once

#include <list>

#include <dune/istl/bcrsmatrix.hh>

#include <amdis/linearalgebra/Common.hpp>
#include <amdis/linearalgebra/Constraints.hpp>

namespace AMDiS
{
  template <class T, class A>
  struct Constraints<Dune::BCRSMatrix<T,A>>
  {
    using Matrix = Dune::BCRSMatrix<T,A>;

    template <class BitVector>
    static std::vector<Triplet<T>> dirichletBC(Matrix& mat, BitVector const& nodes, bool setDiagonal = true)
    {
      // loop over the matrix rows
      for (std::size_t i = 0; i < mat.N(); ++i) {
        if (nodes[i]) {
          auto cIt = mat[i].begin();
          auto cEndIt = mat[i].end();
          // loop over nonzero matrix entries in current row
          for (; cIt != cEndIt; ++cIt)
            *cIt = (setDiagonal && i == cIt.index() ? T(1) : T(0));
        }
      }

      return {};
    }

    template <class BitVector, class Associations>
    static std::vector<Triplet<T>> periodicBC(Matrix& mat, BitVector const& left, Associations const& left2right,
      bool setDiagonal = true)
    {
      error_exit("Not implemented");
      return {};
    }
  };

} // end namespace AMDiS
